<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->

  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-2 mb-2">
      <h2>F100 - Quản trị Người dùng</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="groleSelect" class="form-control">
  
          </select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-user" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
  </div>
  
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>STT</th>
          <th>Username</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>email</th>
          <th>Age</th>
          <th>Role</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];
  var gStt = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter-user").on("click",function() {
    onBtnFilterClick()
  });
  $(document).on("click","#user-table .fa-dice" ,function() {
    onBtnDiceHistoryClick(this)
  })
  $(document).on("click","#user-table .fa-gift" ,function() {
    onBtnVoucherHistoryClick(this)
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  function onPageLoading() {
    "use strict";
    $('#user-table').DataTable({
        data: gUserObjects,
        columns: [
            { data: 'id' },
            { data: 'username' },
            { data: 'firstname' },
            { data: 'lastname.' },
            { data: 'email' },
            { data: 'age' },
            { data: 'roleId' },
            { data: 'action' },
        ],
        columnDefs: [
        { targets: 0,
          
         render: function(data) {
          return gStt++;
         }},
         {targets: 7,
         defaultContent: `<i title=" Dice History " class="fas fa-dice" style = "cursor:pointer;color:blue"></i>&nbsp; <i title = "Voucher History" class="fas fa-gift" style = "cursor:pointer;color:blue"></i>`}
        
      
    ]
    });

    loadDataToSelect(gRoleObjects);
  } 

  function onBtnFilterClick(){
    var vFilterObj = {
      roleId: 0
    }

    getDataFilterObj(vFilterObj);
    var vFilter = filterData(vFilterObj);
    console.log(vFilter)
    displayToTable(vFilter)
  }

  function onBtnDiceHistoryClick(paramData) {
    var vTable = $('#user-table').DataTable();
    var vTableRow = $(paramData).parents('tr');
			var vUserRowData = vTable.row(vTableRow).data();

    var vFirstname = vUserRowData.firstname;
    var vLastname = vUserRowData.lastname;
    var vUsername =  vUserRowData.username;

    window.location.href = "diceHistory.html" + "?firstname=" + vFirstname + "&username=" + vUsername + "&lastname=" + vLastname;
  }


  function onBtnVoucherHistoryClick(paramData) {
    var vTable = $('#user-table').DataTable();
    var vTableRow = $(paramData).parents('tr');
			var vUserRowData = vTable.row(vTableRow).data();

    var vFirstname = vUserRowData.firstname;
    var vLastname = vUserRowData.lastname;
    var vUsername =  vUserRowData.username;

    window.location.href = "voucherHistory.html" + "?firstname=" + vFirstname + "&username=" + vUsername + "&lastname=" + vLastname;
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToSelect(paramData) {
      $("#groleSelect").append($("<option>", {
        value: 0,
        text: "--chon role--"
      }))

      for(var bI = 0 ; bI < paramData.length;bI++){
        $("#groleSelect").append($("<option>", {
        value: paramData[bI].roleId,
        text: paramData[bI].roleName
      }))
      }
    }

    function getDataFilterObj(paramData){
    paramData.roleId = $("#groleSelect").val();
  }
  function filterData(paramData){
    var vResult = [];
    vResult = gUserObjects.filter(function(item) {
      return (item.roleId == paramData.roleId|| paramData.roleId === 0)
    });
    return vResult;
  }
  function displayToTable(paramData){
    gStt = 1;
    var vTable = $('#user-table').DataTable();
    vTable.clear();
    vTable.rows.add(paramData);
    vTable.draw();

  }
</script>
</body>
</html>